enum DataType { text, integer, double }

class TableDatabase {
  String tableName;
  List<ColumnDatabase> column;

  TableDatabase({required this.column, required this.tableName});
}

class ColumnDatabase {
  bool primaryKey, autoIncrement, isNull;
  String name;
  DataType typeData;

  ColumnDatabase({this.autoIncrement = false, this.isNull = false, required this.name, required this.typeData, this.primaryKey = false});
}

class Where {
  String columnName, operator;
  String? value;

  Where(this.columnName, this.operator, this.value);
}

class Transaction {
  List<Where>? where;
  Map<String, String>? data;
  List<Map<String, String>>? listData;

  static String query(Transaction data) {
    if (data.where == null) {
      return '';
    }
    String q = '';
    int count = 0;
    for (Where i in data.where ?? []) {
      ++count;
      if (count == 1) {
        q += 'WHERE ';
      }
      final tryParse = int.tryParse(i.value!);
      q += (i.columnName) + (i.operator);
      if (tryParse == null) {
        q += '"' + i.value!.replaceAll("'", "|_|_|").replaceAll('"', '|-|-|') + '"';
      } else {
        q += tryParse.toString();
      }
      if (count != data.where!.length && data.where!.length > 1) {
        q += ' AND ';
      }
    }

    return q;
  }

  Transaction({this.data, this.where, this.listData});
}

class DatabaseQuery {
  Transaction? get, update, delete, insert;

  DatabaseQuery({this.delete, this.get, this.insert, this.update});
}
